<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="车牌号" prop="licensePlate">
        <el-input
          v-model="queryParams.licensePlate"
          placeholder="请输入车牌号"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="保险单号" prop="policyNumber">
        <el-input
          v-model="queryParams.policyNumber"
          placeholder="请输入保险单号"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="有效期" prop="validityPeriod">
        <el-date-picker clearable
          v-model="queryParams.validityPeriod"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择有效期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="保险公司名称" prop="insuranceCompany">
        <el-input
          v-model="queryParams.insuranceCompany"
          placeholder="请输入保险公司名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['md:insurance:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['md:insurance:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['md:insurance:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['md:insurance:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="insuranceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="车牌号" align="center" prop="licensePlate" />
      <el-table-column label="保险图片" align="center" prop="insuranceImage" width="100">
        <template #default="scope">
          <image-preview :src="scope.row.insuranceImage" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column label="保险单号" align="center" prop="policyNumber" />
      <el-table-column label="保险种类" align="center" prop="insuranceType" />
      <el-table-column label="有效期" align="center" prop="validityPeriod" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.validityPeriod, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="保险公司名称" align="center" prop="insuranceCompany" />
      <el-table-column label="备注" align="center" prop="comment" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['md:insurance:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['md:insurance:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改车辆保险信息对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="insuranceRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="车牌号" prop="licensePlate">
          <el-input v-model="form.licensePlate" placeholder="请输入车牌号" />
        </el-form-item>
        <el-form-item label="保险图片" prop="insuranceImage">
          <image-upload v-model="form.insuranceImage"/>
        </el-form-item>
        <el-form-item label="保险单号" prop="policyNumber">
          <el-input v-model="form.policyNumber" placeholder="请输入保险单号" />
        </el-form-item>
        <el-form-item label="有效期" prop="validityPeriod">
          <el-date-picker clearable
            v-model="form.validityPeriod"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择有效期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="保险公司名称" prop="insuranceCompany">
          <el-input v-model="form.insuranceCompany" placeholder="请输入保险公司名称" />
        </el-form-item>
        <el-form-item label="备注" prop="comment">
          <el-input v-model="form.comment" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Insurance">
import { listInsurance, getInsurance, delInsurance, addInsurance, updateInsurance } from "@/api/md/insurance";

const { proxy } = getCurrentInstance();

const insuranceList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    licensePlate: null,
    insuranceImage: null,
    policyNumber: null,
    insuranceType: null,
    validityPeriod: null,
    insuranceCompany: null,
  },
  rules: {
    licensePlate: [
      { required: true, message: "车牌号不能为空", trigger: "blur" }
    ],
    policyNumber: [
      { required: true, message: "保险单号不能为空", trigger: "blur" }
    ],
    insuranceType: [
      { required: true, message: "保险种类不能为空", trigger: "change" }
    ],
    validityPeriod: [
      { required: true, message: "有效期不能为空", trigger: "blur" }
    ],
    insuranceCompany: [
      { required: true, message: "保险公司名称不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询车辆保险信息列表 */
function getList() {
  loading.value = true;
  listInsurance(queryParams.value).then(response => {
    insuranceList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    licensePlate: null,
    insuranceImage: null,
    policyNumber: null,
    insuranceType: null,
    validityPeriod: null,
    insuranceCompany: null,
    comment: null
  };
  proxy.resetForm("insuranceRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加车辆保险信息";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getInsurance(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改车辆保险信息";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["insuranceRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateInsurance(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addInsurance(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除车辆保险信息编号为"' + _ids + '"的数据项？').then(function() {
    return delInsurance(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('md/insurance/export', {
    ...queryParams.value
  }, `insurance_${new Date().getTime()}.xlsx`)
}

getList();
</script>
